#include<stdio.h>
#include<stdlib.h>

typedef struct _proizvod{
int tip;
unsigned minuta, sat, dan, mjesec, godina;
unsigned x, y, z;
struct _proizvod *next;

}proizvod;

void ispisi(proizvod * proizvodi){

    while(proizvodi!=NULL){
        if(proizvodi->next!=NULL)
            printf("(%u, %u, %u, %u, %u, %u) -> ",proizvodi->tip,proizvodi->minuta, proizvodi->sat, proizvodi->dan,proizvodi->mjesec, proizvodi->godina);
        else
            printf("(%u, %u, %u, %u, %u, %u) ",proizvodi->tip,proizvodi->minuta, proizvodi->sat, proizvodi->dan,proizvodi->mjesec, proizvodi->godina);
            proizvodi=proizvodi->next;
    }

    printf("\n\n");

}

void dealociraj(proizvod *lista){

 proizvod *tmp=lista;

 while(lista!=NULL){

    lista=tmp->next;
    free(tmp);
    tmp=lista;

 }
}

proizvod* spoji(proizvod *proizvodi, proizvod **posiljka){

proizvod *prij=NULL;
proizvod *prTmp=proizvodi;

while(*posiljka!=NULL){
    prij=NULL;

prTmp=proizvodi;
int dodan=0;

    while(prTmp!=NULL){

        if((*posiljka)->godina<prTmp->godina || ((*posiljka)->godina==prTmp->godina && (*posiljka)->mjesec<prTmp->mjesec) || ((*posiljka)->godina==prTmp->godina && (*posiljka)->mjesec==prTmp->mjesec && (*posiljka)->dan<prTmp->dan) || ((*posiljka)->godina==prTmp->godina && (*posiljka)->mjesec==prTmp->mjesec && (*posiljka)->dan==prTmp->dan && (*posiljka)->sat<prTmp->sat) || ((*posiljka)->godina==prTmp->godina && (*posiljka)->mjesec==prTmp->mjesec && (*posiljka)->dan==prTmp->dan && (*posiljka)->sat==prTmp->sat && (*posiljka)->minuta<prTmp->minuta)){
            if(prij==NULL){
                proizvod *tmp=(*posiljka);
                (*posiljka)=(*posiljka)->next;
                tmp->next=prTmp;
                proizvodi=tmp;
                dodan=1;
                break;
            }
            else{
                    proizvod *tmp=(*posiljka);
                    (*posiljka)=(*posiljka)->next;
                    tmp->next=prTmp;
                    prij->next=tmp;
                    dodan=1;
                    break;
            }
        }
        else{
            prij=prTmp;
            prTmp=prTmp->next;
        }
    }

    if(dodan==0){
        prij->next=(*posiljka);
        proizvod *tmp=(*posiljka);
        tmp->next=NULL;
        (*posiljka)=(*posiljka)->next;
        dodan=1;
    }

}
return proizvodi;
}


proizvod* izvadi(proizvod *p, int tip, unsigned *x, unsigned *y, unsigned *z){

proizvod *prij=NULL;
proizvod *first=p;

while(first!=NULL){

    if(first->tip==tip){
        *x=first->x;
        *y=first->y;
        *z=first->z;

        if(prij==NULL){
            proizvod *tmp=first;
            first=first->next;
            free(tmp);
            return first;
        }
        else{
            prij->next=first->next;
            free(first);
            return p;
        }
    }
    else{
    prij=first;
    first=first->next;
    }
}

    return p;
}

proizvod *izdvoji(proizvod** p, int tip, int k, proizvod* izdvojeni){

izdvojeni=NULL;
proizvod *prij=NULL;
proizvod *first=*p;

int brojProizvodaTipa=0;

while(first!=NULL){

if(first->tip==tip)
    brojProizvodaTipa++;

first=first->next;

}

first=*p;

while(first!=NULL){

    if(first->tip==tip){
            if((brojProizvodaTipa-k)>0){
                brojProizvodaTipa--;
                prij=first;
                first=first->next;
                continue;
            }

        if(prij==NULL){
            proizvod *tmp=first;
            first=first->next;
            *p=(*p)->next;
            tmp->next=izdvojeni->next;
            izdvojeni=tmp;
        }
        else{
            if(first->next!=NULL)
            prij->next=first->next;
             proizvod *tmp=first;
             first=first->next;
             if(izdvojeni!=NULL)
             tmp->next=izdvojeni;
             else tmp->next=NULL;
             izdvojeni=tmp;
        }
    }
    else{
    prij=first;
    first=first->next;
    }
}

    return izdvojeni;
}

int main(void){

proizvod *proizvodi;

proizvod *a,*b,*c,*d,*e,*f,*g,*h;

a=(proizvod*) malloc(sizeof(proizvod));
b=(proizvod*) malloc(sizeof(proizvod));
c=(proizvod*) malloc(sizeof(proizvod));
d=(proizvod*) malloc(sizeof(proizvod));
e=(proizvod*) malloc(sizeof(proizvod));
f=(proizvod*) malloc(sizeof(proizvod));
g=(proizvod*) malloc(sizeof(proizvod));
h=(proizvod*) malloc(sizeof(proizvod));

a->tip=2; a->minuta=10; a->sat=8; a->dan=27; a->mjesec=8; a->godina=2016; a->x=4; a->y=10; a->z=2;
b->tip=3; b->minuta=20; b->sat=12; b->dan=28; b->mjesec=9; b->godina=2016; b->x=5; b->y=3; b->z=1;
c->tip=4; c->minuta=30; c->sat=17; c->dan=31; c->mjesec=8; c->godina=2016; c->x=3; c->y=2; c->z=0;
d->tip=2; d->minuta=0; d->sat=22; d->dan=1; d->mjesec=9; d->godina=2016; a->x=4; d->y=9; d->z=0;
e->tip=5; e->minuta=10; e->sat=21; e->dan=5; e->mjesec=9; e->godina=2016; a->x=2; e->y=6; e->z=1;
f->tip=4; f->minuta=50; f->sat=4; f->dan=3; f->mjesec=10; f->godina=2016; a->x=7; f->y=5; f->z=2;
g->tip=1; g->minuta=20; g->sat=3; g->dan=16; g->mjesec=11; g->godina=2016; a->x=6; g->y=4; g->z=0;
h->tip=1; h->minuta=10; h->sat=7; h->dan=30; h->mjesec=12; h->godina=2016; a->x=9; h->y=7; h->z=0;

proizvodi=a; a->next=c; c->next=d; d->next=e; e->next=b; b->next=f; f->next=g; g->next=h; h->next=NULL;
ispisi(proizvodi);

proizvod *posiljka;

proizvod *aN,*bN,*cN,*dN;
aN=(proizvod*) malloc(sizeof(proizvod));
bN=(proizvod*) malloc(sizeof(proizvod));
cN=(proizvod*) malloc(sizeof(proizvod));
dN=(proizvod*) malloc(sizeof(proizvod));

aN->tip=2; aN->minuta=30; aN->sat=17; aN->dan=26; aN->mjesec=8; aN->godina=2016; aN->x=4; aN->y=11; aN->z=2;
bN->tip=2; bN->minuta=50;bN->sat=19; bN->dan=31; bN->mjesec=8; bN->godina=2016; bN->x=54; bN->y=12; bN->z=2;
cN->tip=6; cN->minuta=30; cN->sat=19; cN->dan=11; cN->mjesec=10; cN->godina=2016; cN->x=8; cN->y=5; cN->z=1;
dN->tip=8; dN->minuta=50; dN->sat=20; dN->dan=14; dN->mjesec=11; dN->godina=2016; dN->x=3; dN->y=5; dN->z=2;

posiljka = dN; dN->next=cN; cN->next=aN; aN->next=bN; bN->next=NULL;
ispisi(posiljka);

proizvodi=spoji(proizvodi,&posiljka);
ispisi(proizvodi);

unsigned x,y,z;
proizvodi=izvadi(proizvodi,4,&x,&y,&z);
ispisi(proizvodi);
printf("Koordinate: %u, %u, %u\n\n", x,y,z);

proizvod *izdvojeni;

izdvojeni=izdvoji(&proizvodi,2,2,izdvojeni);
ispisi(proizvodi);
ispisi(izdvojeni);

dealociraj(proizvodi);
dealociraj(posiljka);

return 0;
}
